<?php

	/*	nailer: an image indexer/thumbnailer
		by: Christopher Heschong <chris@wiw.org>
		11/12/2001 (originally written for Brandon)

		Feel free to use this script however you like.
	*/

	include("config.inc");

	// Set some essential defaults
	if (!$rows) { $rows = 5; }
	if (!$cols) { $cols = 5; }

	// Shouldn't need to change anything further
	$url = $SCRIPT_NAME;

	list($null, $command, $arg) = explode("/",$PATH_INFO,3);

	$path = $basedir . "/" . urldecode($arg);

	head($path);

	switch($command) {
		case "v":
			echo show_image_page($path);
		default:
			echo show_thumbs($path);
	}

	foot($path);


	function head($path) {
		$folder_nav = folder_nav($path);
		$link_nav = link_nav($path);
		include("templates/head.html");

	}

	function foot($path) {
		include("templates/foot.html");
	}

	function next_link($path) {
		global $url;

		$file = array_pop(explode("/",$path));
		$dir = join("/",array_slice(explode("/",$path),0,-1));
		list($dirs, $files) = get_contents($dir);

		$next_key = array_search($file,$files) +1;
		if ($next_key >= count($files)) {
			$next_key = 0;
		}

		$next_file = $files[$next_key];

		$link = $url . "/v" . path_shorten($dir) . "/" . $next_file;

		return $link;

	}

	function prev_link($path) {
		global $url;

		$file = array_pop(explode("/",$path));
		$dir = join("/",array_slice(explode("/",$path),0,-1));
		list($dirs, $files) = get_contents($dir);

		$prev_key = array_search($file,$files) -1;
		if ($prev_key < 0) {
			$prev_key = count($files) -1;
		}

		$prev_file = $files[$prev_key];

		$link = $url . "/v" . path_shorten($dir) . "/" . $prev_file;

		return $link;

	}

	function get_contents($path, $start="", $offset="") {
		global $exclude;

		if (is_dir($path)) {
			$h = opendir($path);
			while (false !== ($file = readdir($h))) {
				if (!ereg("^\.",$file) && (!in_array($file, $exclude))) {
					if (is_dir($path . "/" . $file)) { $dirs[] = urlencode($file); }
					else { $files[] = $file; }
				}
			}
			closedir($h);
		}

		if ($start || $offset) {
			if (is_array($files)) {
				$files = array_slice($files, $start, $offset);
			}
		}

		if (is_array($dirs)) {
			sort($dirs);
		}
		if (is_array($files)) {
			sort($files);
		}

		return array($dirs, $files);
	}

	function path_shorten($path) {
		global $basedir;
		return str_replace($basedir,"",$path);
	}

	function folder_nav($path) {
		global $SCRIPT_NAME, $basedir, $icons;
		list($dirs,$files) = get_contents($path);

		if (is_array($dirs)) {
			foreach ($dirs as $dir) {

				$dir = path_shorten($path) . "/" . $dir;
				$dir = str_replace("//","/",$dir);

				$str .= <<<EOT

<img src="$icons/directory.gif" alt="Directory">
<a href=$SCRIPT_NAME/0$dir>$dir</a><br />

EOT;
			}
		}
		return $str;

	}

	function link_nav($path) {
		global $SCRIPT_NAME;
		$path = path_shorten($path);
		$parts = explode("/",$path);
		foreach ($parts as $part) {
			if ($part) {
				$ag_path .= "/" . $part;
				$link[] = "<a href=\"$SCRIPT_NAME/0$ag_path\">$part</a>";
			}
		}




		if (is_array($link)) {
			array_pop($link);
			$piece = array_pop($parts);
			$link = join(" / ",$link) . "/" . $piece;
			if (!ereg("^/",$link)) {
				$link = " / " . $link;
			}
		}

		$link = "/<a href=\"$SCRIPT_NAME\">album</a>" . $link;
		return $link;
	}
	
	function show_thumbs($path) {
		global $url, $cols, $rows, $size, $trelative, $tmpdir;

		global $command;

		$start = $command;

		$dir = path_shorten($path);

		list($dirs,$files) = get_contents($path, $start, ($rows*$cols));
		list($all_dirs,$all_files) = get_contents($path);

		if (is_readable($path . "/README") && $start == 0) {
			$readme = join("",file($path . "/README"));
		}

		if (is_array($files)) {

			$next = ($start + ($rows*$cols));
			$prev = ($start - ($rows*$cols));
			$last = count($all_files) - (count($all_files)%($rows*$cols));

			if ($last == count($all_files)) {
				$last = count($all_files) - ($rows*$cols);
			}
			
			if (count($all_files) > $next) {
				$next_link = $url . "/$next" . $dir;
			}
			else {
				$next_link = $url . "/0" . $dir;
			}

			if ($prev >= 0) {
				$prev_link = $url . "/$prev" . $dir;
			}
			else {
				$prev_link = $url . "/$last" . $dir;
			}

			$table .= "<table width=\"100%\"><tr>";

			foreach ($files as $file) {

				if (is_file($path . "/" . $file)) {
					$hw = GetImageSize($path . "/" . $file);
					if ($hw[0] > $size) {

						$thumb = thumbnail($path . "/" . $file);

						$thw = GetImageSize(str_replace($trelative, $tmpdir, $thumb));
						$x = $thw[0];
						$y = $thw[1];
						
						if (!($i%$cols)) {
							$table .= "</tr><tr>";
						}

						$i++;

						$percent = 100/$cols;
						$link = "$url/v$dir/$file";

						$table .= <<<EOT

<td width="$percent%" align="center">
<a href="$link"><img src="$thumb" alt="$file" border="1" height="$y" width="$x" /></a>
</td>

EOT;

					}
				}
			}

			$table .= "</tr></table>";

		}

		include("templates/show_thumbs.html");
	}

	function thumbnail($path) {
		global $trelative, $tmpdir, $size;

		$file = $tmpdir . "/" . str_replace("/","_",$path);
		if (!is_readable($file) || (filemtime($file) < filemtime($path))) {
			$hw = GetImageSize($path);

			$x = $size;
			$y = $hw[1]/($hw[0]/$size);

			if ($y > $x) {
				$x = round(($size)*($hw[0])/$hw[1]);
				$y = $size;
			}

			$src = imagecreatefrom($path);
			$new = imagecreate($x, $y);

			imagecopyresized($new, $src, 0, 0, 0, 0, $x, $y, $hw[0], $hw[1]);

			imagejpeg($new,$file,100);

		}

		return str_replace($tmpdir,$trelative,$file);

	}


	function imagecreatefrom($tmpfile) {
		$type = imagetype(join("",file($tmpfile)));
		switch ($type) {
			case "gif":
				$new_img = imagecreatefromgif($tmpfile);
				break;
			case "png":
				$new_img = imagecreatefrompng($tmpfile);
				break;
			case "jpeg":
			default:
				$new_img = imagecreatefromjpeg($tmpfile);
		}
		return $new_img;
	}

	function imagetype($data) {
		$sub = substr($data, 0, 20);
		if (preg_match("/GIF/",$sub)) {
			$str = "gif";
		}
		if (preg_match("/JFIF/",$sub)) {
			$str = "jpeg";
		}
		if (preg_match("/Exif/",$sub)) {
			$str = "jpeg";
		}
		if (preg_match("/PNG/", $sub)) {
			$str = "png";
		}
		return $str;
	}

	function show_image_page($path) {
		global $relative;

		$file = path_shorten($path);
		$src = $relative . $file;

		$next_link = next_link($path);
		$prev_link = prev_link($path);
		
		$hw = GetImageSize($path);
		$x = $hw[0];
		$y = $hw[1];

		include("templates/image_page.html");

	}

?>
